#! /usr/bin/env python3
# -*- coding:UTF-8 -*-

#--------------Driver Library-----------------#
import os
os.chdir("/home/pi/christmas")
import RPi.GPIO as GPIO
import OLED_Driver as OLED
import time
import datetime
import math
#--------------Image Library---------------#
from PIL  import Image
from PIL import ImageDraw
from PIL import ImageFont
from PIL import ImageColor

#-------------Christmas Countdown Display Functions---------------#

def Display_Text():
    image = Image.new("RGB", (OLED.SSD1351_WIDTH, OLED.SSD1351_HEIGHT), "BLACK")
    draw = ImageDraw.Draw(image)
    font = ImageFont.truetype('cambriab.ttf',24)
    font2 = ImageFont.truetype('cambriab.ttf',18)

    christmas = datetime.datetime.strptime("12/25/2020", "%m/%d/%Y")
    now = datetime.datetime.now()
    diff = christmas - now
    days = diff.days
    seconds = int(diff.seconds)
    hours = int(math.floor(seconds / 3600))
    minutes = int(math.floor((seconds - (hours * 3600)) / 60))
    secs = seconds - (hours * 3600) - (minutes * 60)
    strHours = str(hours)
    strMinutes = str(minutes)
    strSeconds = str(secs)
    if secs < 10:
        strSeconds = "0" + strSeconds
    if minutes < 10:
        strMinutes = "0" + strMinutes
    if hours < 10:
        strHours = " " + strHours
    strDaysLeft = str(days) + " Days"
    strHMS = str(strHours) + ":" + str(strMinutes) + ":" + str(strSeconds)
    draw.text((0, 12), 'Days Until', fill = "GREEN", font = font)
    draw.text((0, 36), 'Christmas', fill = "RED",font = font)
    draw.text((20, 60), str(strDaysLeft), fill = "GREEN", font = font2)
    draw.text((20, 80), str(strHMS), fill = "RED", font = font2)
    draw.text((0,110), '  12/25/2020', fill = "WHITE", font = font2)

    OLED.Display_Image(image)
    OLED.Delay(900)


#----------------------MAIN-------------------------#

try:


    def main():
        #-------------OLED Init------------#
        OLED.Device_Init()

        #-------------Draw Pictures------------#
        #- Loop until break - #
        while (True):
            i = 1
            #- Loop clock for 10 seconds - #
            while i < 10:
                Display_Text()
                i += 1
            #- Display images for 2 seconds each - #
            else:
                image2 = Image.open("santa.jpg")
                image3 = Image.open("tree1.jpg")
                OLED.Display_Image(image2)
                OLED.Delay(2000)
                OLED.Display_Image(image3)
                OLED.Delay(2000)

    #- Call main sub routine -#
    if __name__ == '__main__':
        main()


except:
    print("\r\nEnd")
    OLED.Clear_Screen()
    GPIO.cleanup()

